> ## Documentation Index
> Fetch the complete documentation index at: https://docs.up.telestream.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Submit a job to the workflow with the specified identifier.

> Submit a job to the workflow with the specified identifier.  The workflow must be active in order for this call to be made.



## OpenAPI

````yaml https://api.up.telestream.com/workflow/api/v1/openapi.yaml post /{space_id}/workflows/{workflow_id}/jobs
openapi: 3.0.3
info:
  title: UP.Workflow API Specification
  version: 1.0.0
  description: Telestream UP.Workflow API Specification
  termsOfService: https://www.telestream.net/telestream-cloud/terms.htm
  contact:
    name: API Support
    url: https://www.telestream.com
    email: cloudsupport@telestream.net
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
servers:
  - url: https://api.up.telestream.com/workflow/api/v1
security:
  - BearerAuth: []
tags:
  - name: workflow
    description: Operations related to the workflow level
  - name: job
    description: Operations related to the job level
  - name: access
    description: Operations related to the access level
paths:
  /{space_id}/workflows/{workflow_id}/jobs:
    parameters:
      - $ref: '#/components/parameters/space_id'
      - $ref: '#/components/parameters/workflow_id'
    post:
      tags:
        - job
      summary: Submit a job to the workflow with the specified identifier.
      description: >-
        Submit a job to the workflow with the specified identifier.  The
        workflow must be active in order for this call to be made.
      operationId: submitWorkflowJob
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubmitJobRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WorkflowJob'
          description: Job submitted successfully
        '400':
          description: Invalid request (e.g. workflow_id is not a valid GUID)
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
        '422':
          $ref: '#/components/responses/Unprocessable'
        '500':
          $ref: '#/components/responses/InternalError'
      security:
        - BearerAuth:
            - workflow:workflow-management
components:
  parameters:
    space_id:
      name: space_id
      description: UP Space Id
      schema:
        type: string
        format: uuid
        example: d290f1ee-6c54-4b01-90e6-d701748f0851
      in: path
      required: true
    workflow_id:
      name: workflow_id
      description: Unique identifier of a Workflow
      schema:
        type: string
        format: uuid
        example: e3c908ad-dc8f-4edb-88f7-c84dec0aef99
      in: path
      required: true
  schemas:
    SubmitJobRequest:
      type: object
      properties:
        job_name:
          type: string
          description: Optional name for the job. Auto-generated if omitted.
          example: My Transcoding Job
        usage:
          $ref: '#/components/schemas/WorkflowJobInput'
    WorkflowJob:
      type: object
      properties:
        id:
          description: Unique Job Identifier
          type: string
          readOnly: true
          example:
            - e75e68e192e6fc04ea3940d302d7bec5
        name:
          description: Workflow Job Name
          type: string
          example:
            - Sample Workflow Job Name
        workflow_id:
          description: The identifier of the workflow associated with this job
          type: string
          readOnly: true
          example:
            - e3c908ad-dc8f-4edb-88f7-c84dec0aef99
        workflow_name:
          description: The name of the workflow that this job was associated with
          type: string
          example:
            - MyWorkflow
        progress:
          description: Workflow Job Progress
          type: number
          readOnly: true
          example:
            - 90
        state:
          $ref: '#/components/schemas/JobState'
        workflow_version:
          description: Workflow Version indicates the revision name
          type: string
        created_at:
          format: date-time
          description: >-
            Timestamp when Workflow Job was created as UTC time in iso8601
            format
          type: string
          readOnly: true
          example:
            - '2020-01-21T15:53:12.388317Z'
        updated_at:
          format: date-time
          description: >-
            Timestamp when Workflow Job was updated as UTC time in iso8601
            format
          type: string
          readOnly: true
          example:
            - '2020-01-22T15:53:12.182617Z'
        elapsed_time:
          format: TimeSpan
          description: >-
            The elapsed time for the workflow job processing calculated as the
            difference between created_at and updated_at timestamps. This field
            is only populated when the workflow job is in a terminal state such
            as succeeded, failed or stopped.
          type: string
          readOnly: true
          nullable: true
          example:
            - 136.08:01:23.5
            - '1:23:45'
    ErrorResponse:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: integer
          format: int32
          description: HTTP status code
          example: 500
        message:
          type: string
          description: Error description
          example: An unexpected error occurred
    WorkflowJobInput:
      type: object
      properties:
        input:
          type: object
          properties:
            variables:
              type: array
              description: >-
                List of variables that are required by the workflow; these
                variables must be provided when submitting a job to the workflow
              items:
                $ref: '#/components/schemas/WorkflowVariable'
            media_nicknames:
              type: array
              description: >-
                List of source media nicknames that are required by the
                workflow; these nicknames must be provided when submitting a job
                to the workflow
              items:
                $ref: '#/components/schemas/WorkflowNickName'
            attachments:
              type: array
              description: >-
                List of source attachment nicknames that are required by the
                workflow; these nicknames must be provided when submitting a job
                to the workflow
              items:
                $ref: '#/components/schemas/WorkflowAttachment'
            labels:
              type: array
              description: >-
                List of labels that are required by the workflow; these labels
                must be provided when submitting a job to the workflow
              items:
                $ref: '#/components/schemas/WorkflowLabel'
    JobState:
      enum:
        - created
        - in-process
        - succeeded
        - failed
        - stopped
        - retry
        - malfunctioned
      type: string
      readOnly: true
      example:
        - in-process
        - succeeded
        - failed
    WorkflowVariable:
      required:
        - name
        - typecode
      type: object
      properties:
        identifier:
          description: GUID for the variable
          type: string
          readOnly: true
          example:
            - 8a0e8e0d-0000-0000-0000-000000000001
        name:
          description: Workflow Variable name
          type: string
          readOnly: true
          example:
            - AudioChannels
        typecode:
          description: |
            typecode:
              * `Boolean` - True | False
              * `Byte` - 8 bit unsigned value (0x0 … 0x255)
              * `Int16` - 16 bit signed integer value
              * `Int32` - 32 bit signed integer value
              * `UInt32` - 32 bit unsigned integer value
              * `String` - A string value
              * `Uri` - A path to a file (specified as a fully qualified Uri)
              * `TimeCode` - A timecode value in the form: HH:MM:SS:FF@framerate, where framerate can be:  23.976, 24, 25, 29.97, 30, 50, 60
          enum:
            - Boolean
            - Byte
            - Int16
            - Int32
            - UInt32
            - String
            - Uri
            - TimeCode
            - Double
          type: string
          readOnly: true
          example:
            - Int16
        default:
          description: Default Workflow Variable Value
          type: string
          example:
            - '1'
        value:
          description: The value field is what the user is free to populate
          type: string
          example:
            - '2'
    WorkflowNickName:
      type: object
      properties:
        name:
          description: Workflow NickName name
          type: string
          readOnly: true
          example:
            - CML
        description:
          description: The description of the Workflow NickName
          type: string
          readOnly: true
          example:
            - A version of material capable of being used in CML solutions.
        identifier:
          description: >-
            The well known identifier for the Workflow NickName that must be
            used when submitting a job to the workflow if that workflow requires
            the source to be provided as part of the job submission.  This is
            the value that must be used in the `sources` section of the job
            submission when submitting a job to a workflow that has defined
            nicknames.
          type: string
          readOnly: true
          example:
            - 8a60b468-0895-4dba-9489-7f4fe93549c5
        files:
          type: array
          description: >-
            A list of files that are associated with the nickname.  These files
            are typically used to provide reference data for the workflow job
            such as LUTs, watermarks, or other auxiliary files that can be
            referenced in the workflow job as part of processing.  The first
            entry in the list is considered to be the root file of the
            collection.
          items:
            type: string
    WorkflowAttachment:
      type: object
      properties:
        name:
          description: Workflow Attachment
          type: string
          readOnly: true
          example:
            - CML
        description:
          description: The description of the Workflow Attachment
          type: string
          readOnly: true
          example:
            - A version of material capable of being used in CML solutions.
        identifier:
          description: >-
            The well known identifier for the Workflow Attachment that must be
            used when submitting a job to the workflow if that workflow requires
            the source to be provided as part of the job submission. This is the
            value that must be used in the `sources` section of the job
            submission when submitting a job to a workflow that has defined
            attachments.
          type: string
          readOnly: true
          example:
            - 8a60b468-0895-4dba-9489-7f4fe93549c5
        file:
          type: string
          description: A file that is associated with the attachment.
    WorkflowLabel:
      type: object
      properties:
        name:
          description: Workflow NickName name
          type: string
          readOnly: true
          example:
            - CML
        description:
          description: The description of the Workflow NickName
          type: string
          readOnly: true
          example:
            - A version of material capable of being used in CML solutions.
        identifier:
          description: >-
            The well known identifier for the Workflow NickName that must be
            used when submitting a job to the workflow if that workflow requires
            the source to be provided as part of the job submission.  This is
            the value that must be used in the `sources` section of the job
            submission when submitting a job to a workflow that has defined
            nicknames.
          type: string
          readOnly: true
          example:
            - 8a60b468-0895-4dba-9489-7f4fe93549c5
        parameters:
          description: >-
            List of parameters that comprise a label.  Each parameter represents
            a discrete piece of information that can be used by the workflow
            during processing.  The parameters are defined at the time of
            workflow design and are populated with values at the time of job
            submission.  The parameters that are associated with a label are
            made available to the workflow in the same way as variables and can
            be used to drive conditional logic, provide values for workflow
            functions or be used in any other way that variables are used within
            the workflow.
          type: array
          items:
            $ref: '#/components/schemas/WorkflowParameter'
    WorkflowParameter:
      required:
        - name
        - typecode
      type: object
      properties:
        identifier:
          description: GUID for the variable
          type: string
          readOnly: true
          example:
            - 8a0e8e0d-0000-0000-0000-000000000001
        name:
          description: Workflow Variable name
          type: string
          readOnly: true
          example:
            - AudioChannels
        typecode:
          description: |
            typecode:
              * `Boolean` - True | False
              * `Byte` - 8 bit unsigned value (0x0 … 0x255)
              * `Int16` - 16 bit signed integer value
              * `Int32` - 32 bit signed integer value
              * `UInt32` - 32 bit unsigned integer value
              * `String` - A string value
              * `Uri` - A path to a file (specified as a fully qualified Uri)
              * `TimeCode` - A timecode value in the form: HH:MM:SS:FF@framerate, where framerate can be:  23.976, 24, 25, 29.97, 30, 50, 60
          enum:
            - Boolean
            - Byte
            - Int16
            - Int32
            - UInt32
            - String
            - Uri
            - TimeCode
            - Double
          type: string
          readOnly: true
          example:
            - Int16
        default_value:
          description: Default Workflow Variable Value
          type: string
          example:
            - '1'
        value:
          description: The value field is what the user is free to populate
          type: string
          example:
            - '2'
        description:
          description: >-
            The optional description of the Workflow Parameter that can be used
            to provide additional information to the user about the purpose of
            the parameter and any constraints on the values that can be provided
            for the parameter.
          type: string
          example:
            - This parameter controls the number of audio channels.
        minimum_value:
          description: The minimum value that can be assigned to the Workflow Parameter.
          type: string
          example:
            - '1'
        maximum_value:
          description: The maximum value that can be assigned to the Workflow Parameter.
          type: string
          example:
            - '10'
        increment_value:
          description: >-
            The increment value corresponds to the step size by which the value
            of the Workflow Parameter can be adjusted.  The increment value is
            traditionally only valid when the typecode is some variation of a
            numeric value.
          type: string
          example:
            - '1'
        options:
          type: object
          description: >-
            A list of optional values that may be used for the parameter value.
            The options field is populated when the parameter was designed to
            allow the selection of a specific subset of values.  The allowable
            values are stored in the options field.
          example:
            - options:
                option1:
                  - red
                option2:
                  - green
                option3:
                  - blue
          additionalProperties:
            type: array
            items:
              type: string
  responses:
    Unauthorized:
      content:
        application/json:
          schema:
            type: object
            properties:
              error_message:
                type: string
            example:
              error_message: You don't have permission to access this resource
      description: Not authorized
    NotFound:
      content:
        application/json:
          schema:
            type: object
            properties:
              error_message:
                type: string
            example:
              error_message: 404 Not found
      description: Item not found
    Unprocessable:
      content:
        application/json:
          schema:
            type: object
            properties:
              errors:
                type: object
                additionalProperties:
                  type: string
            example:
              errors:
                store_id: Store with given ID does not exist or is invalid
      description: Invalid options provided
    InternalError:
      content:
        application/json:
          schema:
            type: object
            properties:
              error_message:
                type: string
            example:
              error_message: 500 internal error
      description: 500 Internal error
  securitySchemes:
    BearerAuth:
      type: oauth2
      description: API key passed as a Bearer token in the Authorization header
      flows:
        implicit:
          authorizationUrl: /auth/oauth2
          scopes:
            workflow:access: Basic access
            workflow:workflow-management: Management access
            workflow:admin: Admin access

````